use crate::common::args::Cli;

use std::{path::PathBuf, time::Duration};

const DEFAULT_TIMEOUT_LEN: u64 = 5000; // ms
const DEFAULT_DELAY_LEN: u64 = 500; // ms
const DEFAULT_WIN_AFTER: usize = 20;

#[derive(Clone)]
pub struct Config {
    pub addr: std::net::SocketAddr,
    pub timeout: Duration,
    pub delay: Duration,
    pub win_after: usize,
    pub key: PathBuf,
    pub certs: PathBuf,
}

impl Config {
    pub fn new(cli: &Cli) -> Self {
        Config {
            addr: cli.addr.clone(),
            timeout: Duration::from_millis(DEFAULT_TIMEOUT_LEN),
            delay: Duration::from_millis(DEFAULT_DELAY_LEN),
            win_after: DEFAULT_WIN_AFTER,
            key: cli.key.clone(),
            certs: cli.certs.clone(),
        }
    }
}
